	/**     Action, Condition, Effect */
		
	function Command(){
		this.parsed = false;	//     
		this.id = "";			//  ,       xml,   
		this.event = "";		// ,    
		this.eventParam = null; //    ,   
		this.body = "";			//      ,       
		this.type = "unknown";	//   -    - Action  Condition 
	}
	
	/**    id, event, eventParam, body. 	
	*      action  condition  xml'e */
	Command.prototype.init = function(actionNode){ 
		this.parsed = false;
			
		var xmlAttributeMap = null;
		var xmlAttribute = null;
		
		xmlAttributeMap = actionNode.attributes;
				if (xmlAttributeMap){
	
		
					xmlAttribute =	xmlAttributeMap.getNamedItem("id");
					if (xmlAttribute != null && xmlAttribute.specified){
						this.id = xmlAttribute.value;
					}
					xmlAttribute =	xmlAttributeMap.getNamedItem("event");
					if (xmlAttribute != null && xmlAttribute.specified){
						this.event = xmlAttribute.value;
					
					}
					xmlAttribute =	xmlAttributeMap.getNamedItem("eventParam");
					if (xmlAttribute != null && xmlAttribute.specified){
						this.eventParam = xmlAttribute.value;
					}
				}
		
		this.body = actionNode.textContent;
		}
	
	/**   	,  .    */	
	Command.prototype.getCommand = function(){
		return this.parsed ? this.body : this.parseBody();
	}

	
	
	
	/**    */
	function Action(){
	
		this.type = "action";
		
		/**    .    */
		this.parseBody = function(){	
			
			//    
			this.body = scene.Utils.replaceString(this.body, "\r", "");
			this.body = scene.Utils.replaceString(this.body, "\t", "");
			this.body = scene.Utils.replaceString(this.body, "\n", "");
			
			
			var actions = (this.body).split(";");	//      ,   actions 
			var parsedCommand = null;
			this.body= new Array();	
			
			for(var i = 0; i < actions.length; i++){
			
			
				var newCommand = actions[i].split(":");	//     / 
			
				for (var j = 0; j < newCommand.length; ++j)
					scene.Utils.trim(newCommand[j]);	//   
				if(newCommand.length > 2){
					for (var j = 2; j < newCommand.length; ++j){
						newCommand[1] += ":" + newCommand[j];
					}			
					parsedCommand = new Array(newCommand[0], newCommand[1]);
				} else {
					parsedCommand = newCommand;	
				}
				parsedCommand.eventParam=this.eventParam;
				this.body.push(parsedCommand);	//     
			}			
			this.parsed = true;
			return this.body;
		}	
	}

	Action.prototype = new Command();
	
	/**    */
	function Condition(){	
		this.type = "condition";
		
		/**    .    */
		this.parseBody = function(){

			//    
			this.body = scene.Utils.replaceString(this.body, "\n", ""); 
			this.body = scene.Utils.replaceString(this.body, "\r", ""); 
			this.body = scene.Utils.replaceString(this.body, "\t", ""); 
			
			var commandForEvaluate = this.body;
			
			//	    -  
			for(var i = 0; i < this.body.length; i++){
				if(this.body[i] == "["){
				var closeParenthesis = this.body.indexOf("]", i);
				var objectName = this.body.slice(i + 1, closeParenthesis);
				var closeProperty = (this.body.slice(closeParenthesis + 2)).search(/\W/);
				var propertyName = this.body.slice(closeParenthesis + 2, (closeParenthesis + closeProperty + 2));
				commandForEvaluate = scene.Utils.replaceString(commandForEvaluate, "[" + objectName + "]." + propertyName,
					"getObjectProperty(\"" + objectName + "\", \"" + propertyName + "\")");
				}
			}
			//	Extra tests	========================================================= 
			//	     ,   test()   
			var testIndex = commandForEvaluate.indexOf("test(");
			while(testIndex >= 0){
				var closeParenthesis = commandForEvaluate.indexOf(")", (testIndex + 5));
				var testContent = commandForEvaluate.slice(testIndex + 5, closeParenthesis);
				var testParams = testContent.split(",");
				var replaceWith = "false";
				if(testParams.length >= 2){
				switch(testParams[0]){
				case "isStepVisited":
					replaceWith = "scene.Labwork.resultManager.getStepVisited(" + parseInt(testParams[1]) + ")";
					break;
				case "isStepExec":				 
					replaceWith = "scene.Labwork.resultManager.getStepResult(" + parseInt(testParams[1]) + ")";
					break;
				case "isStepComplete":
					replaceWith = "scene.Labwork.resultManager.getSceneComplete(" + parseInt(testParams[1]) + ")";
					break;
				case "isStepIdComplete":
				default:
					trace("#FF0000:    condition: test(" + testContent + ")");
				}
				}
				commandForEvaluate = scene.Utils.replaceString(commandForEvaluate, "test(" + testContent + ")", replaceWith);
				testIndex = commandForEvaluate.indexOf("test(");
			}
			//	   actions	=========================================== 
			for(var i = 0; i < commandForEvaluate.length; i++){
				if(commandForEvaluate[i] == "{"){
				var closeParenthesis = commandForEvaluate.indexOf("}", i);
				var actionCommand = commandForEvaluate.slice(i + 1, closeParenthesis);
				var actions = (actionCommand).split(";");
				for(var j = 0; j < actions.length; j++){
					var parsedCommand = null;
					var newCommand = actions[j].split(":");
					if(newCommand.length > 2){
					for (var k = 2; k < newCommand.length; ++k)
						newCommand[1] += ":" + newCommand[k]
					parsedCommand = new Array(newCommand[0], newCommand[1]);
					}
					else
					parsedCommand = newCommand;
					
					var evalCommand = "this.dispatchAction(new Array(\""
					+ parsedCommand[0] + "\", \"" + parsedCommand[1] + "\"));";
					
					commandForEvaluate = scene.Utils.replaceString2(
					commandForEvaluate,
					parsedCommand[0] + ":" + parsedCommand[1],
					evalCommand);
				};
				}
			}
			this.body=commandForEvaluate;
			this.parsed = true;
			return this.body;
		}
	}
	
	Condition.prototype = new Command();

